package com.simuwang.manage.service.impl;

import com.simuwang.base.mapper.CompanyEmailConfigMapper;
import com.simuwang.base.pojo.dos.CompanyEmailConfigDO;
import com.simuwang.base.pojo.vo.CompanyEmailConfigVO;
import com.simuwang.base.pojo.vo.SuccessVO;
import com.simuwang.manage.service.CompanyEmailConfigService;
import com.smppw.common.pojo.enums.status.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * FileName: CompanyEmailConfigServiceImpl
 * Author:   chenjianhua
 * Date:     2024/9/7 12:55
 * Description: ${DESCRIPTION}
 */
@Service
public class CompanyEmailConfigServiceImpl implements CompanyEmailConfigService {
    @Autowired
    private CompanyEmailConfigMapper companyEmailConfigMapper;
    @Override
    public SuccessVO saveCompanyEmailConfig(List<CompanyEmailConfigVO> companyEmailConfigVOS) {
        SuccessVO saveSuccessVO = new SuccessVO();
        try{
            for(CompanyEmailConfigVO emailConfigVO : companyEmailConfigVOS){
                CompanyEmailConfigDO emailConfigDO = new CompanyEmailConfigDO();
                emailConfigDO.setCompanyId(emailConfigVO.getCompanyId());
                emailConfigDO.setCompanyName(emailConfigVO.getCompanyName());
                emailConfigDO.setEmail(emailConfigVO.getEmail());
                emailConfigDO.setOpenStatus(emailConfigVO.getOpenStatus());
                emailConfigDO.setIsvalid(1);
                emailConfigDO.setUpdateTime(new Date());
                if(emailConfigVO.getId() != null){
                    emailConfigDO.setId(emailConfigVO.getId());
                    companyEmailConfigMapper.updateCompanyEmailConfig(emailConfigDO);
                }else{
                    emailConfigDO.setCreateTime(new Date());
                    companyEmailConfigMapper.saveCompanyEmailConfig(emailConfigDO);
                }
            }
            saveSuccessVO.setStatus(1);
            saveSuccessVO.setMsg(ResultCode.SAVE_SUCCESS.getMsg());
        }catch (Exception e){
            saveSuccessVO.setStatus(0);
            saveSuccessVO.setMsg(ResultCode.SAVE_FAILED.getMsg());
        }
        return saveSuccessVO;
    }

    @Override
    public SuccessVO deleteCompanyEmailConfig(Integer id) {
        SuccessVO saveSuccessVO = new SuccessVO();
        try {
            CompanyEmailConfigDO configDO = companyEmailConfigMapper.selectById(id);
            if (configDO != null) {
                configDO.setIsvalid(0);
                configDO.setUpdateTime(new Date());
                companyEmailConfigMapper.updateById(configDO);
            }
            saveSuccessVO.setStatus(1);
            saveSuccessVO.setMsg(ResultCode.DELETE_SUCCESS.getMsg());
        }catch (Exception e){
            saveSuccessVO.setStatus(0);
            saveSuccessVO.setMsg(ResultCode.DELETE_FAILED.getMsg());
        }
        return saveSuccessVO;
    }

    @Override
    public SuccessVO updateCompanyEmailConfig(CompanyEmailConfigVO companyEmailConfigVO) {
        SuccessVO saveSuccessVO = new SuccessVO();
        try {
            CompanyEmailConfigDO configDO = companyEmailConfigMapper.selectCompanyEmailConfigById(companyEmailConfigVO.getId());
            if(configDO != null){
                configDO.setEmail(companyEmailConfigVO.getEmail());
                configDO.setCompanyId(companyEmailConfigVO.getCompanyId());
                configDO.setCompanyName(companyEmailConfigVO.getCompanyName());
                configDO.setUpdateTime(new Date());
                companyEmailConfigMapper.updateCompanyEmailConfig(configDO);
            }
            saveSuccessVO.setStatus(1);
            saveSuccessVO.setMsg(ResultCode.SUCCESS.getMsg());
        }catch (Exception e){
            saveSuccessVO.setStatus(0);
            saveSuccessVO.setMsg(ResultCode.SAVE_FAILED.getMsg());
        }
        return saveSuccessVO;
    }
}
