package com.simuwang.manage.service.impl;

import com.simuwang.base.mapper.CompanyEmailConfigMapper;
import com.simuwang.base.mapper.CompanyEmailSendHistoryMapper;
import com.simuwang.base.pojo.vo.CompanyEmailConfigVO;
import com.simuwang.base.pojo.vo.CompanyEmailSendHistoryVO;
import com.simuwang.base.pojo.vo.SuccessVO;
import com.simuwang.manage.service.CompanyEmailSendHistoryService;
import com.smppw.common.pojo.enums.status.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * FileName: CompanyEmailSendHistoryServiceImpl
 * Author:   chenjianhua
 * Date:     2024/9/9 10:06
 * Description: ${DESCRIPTION}
 */
@Service
public class CompanyEmailSendHistoryServiceImpl implements CompanyEmailSendHistoryService {
    @Autowired
    private CompanyEmailSendHistoryMapper companyEmailSendHistoryMapper;

    @Autowired
    private CompanyEmailConfigMapper companyEmailConfigMapper;
    @Override
    public List<CompanyEmailSendHistoryVO> searchCompanyEmail(String companyName, String email, Integer sendStatus) {
        return companyEmailSendHistoryMapper.searchCompanyEmailList(companyName,email,sendStatus);
    }

    @Override
    public List<CompanyEmailSendHistoryVO> searchEmailHistory(String companyId) {
        return companyEmailSendHistoryMapper.searchEmailHistory(companyId);
    }

    @Override
    @Transactional
    public SuccessVO deleteEmail(String companyId) {
        SuccessVO successVO = new SuccessVO();
        try{
            List<String> emailList = companyEmailConfigMapper.searchEmailByCompanyId(companyId);
            //删除配置
            companyEmailConfigMapper.deleteCompanyEmailConfig(companyId);
            //删除历史
            if(emailList.size() > 0){
                companyEmailSendHistoryMapper.deleteEmailHistory(emailList);
            }
            successVO.setStatus(1);
            successVO.setMsg(ResultCode.DELETE_SUCCESS.getMsg());
        }catch (Exception e){
            successVO.setStatus(0);
            successVO.setMsg(ResultCode.DELETE_FAILED.getMsg());
        }
        return successVO;
    }

    @Override
    public SuccessVO deleteEmailHistory(List<Integer> idList) {
        SuccessVO successVO = new SuccessVO();
        try {
            companyEmailSendHistoryMapper.deleteEmailHistoryByIds(idList);
            successVO.setStatus(1);
            successVO.setMsg(ResultCode.DELETE_SUCCESS.getMsg());
        }catch (Exception e){
            successVO.setStatus(0);
            successVO.setMsg(ResultCode.DELETE_FAILED.getMsg());
        }
        return successVO;
    }

    @Override
    public List<CompanyEmailConfigVO> searchEmailConfig(String companyId) {
        return companyEmailConfigMapper.searchEmailConfig(companyId);
    }
}
